stages:
  - test
  - build
  - release

variables:
  PROJECT_PATH: commonground/core/broom
  RELEASE_IMAGE_REPOSITORY: "${CI_REGISTRY}/${PROJECT_PATH}"


Lint:
  stage: test
  image: golangci/golangci-lint:v1.49.0-alpine
  before_script:
   - apk --no-cache add jq
  script:
    # Based on https://docs.gitlab.com/ee/development/go_guide/index.html#automatic-linting
    - golangci-lint run --out-format code-climate | tee gl-code-quality-report.json | jq -r '.[] | "\(.location.path):\(.location.lines.begin) \(.description)"'
  artifacts:
    reports:
      codequality: gl-code-quality-report.json
  tags:
    - cg
    - docker

Build:
  stage: build
  image: docker:20.10.22-git
  services:
    - docker:20.10.22-dind
  before_script:
    - export IMAGE_REPOSITORY="${RELEASE_IMAGE_REPOSITORY}/tmp"
    - export IMAGE_TAG="${CI_COMMIT_SHORT_SHA}"
    - echo "${CI_REGISTRY_PASSWORD}" | docker login --username "${CI_REGISTRY_USER}" --password-stdin "${CI_REGISTRY}"
  script:
    - docker compose build
    - docker compose push
    - echo -n "${IMAGE_REPOSITORY}:${IMAGE_TAG}" > ci_build_image.txt
  artifacts:
    paths:
      - ci_build_image.txt
  tags:
    - cg
    - docker

Release:
  stage: release
  image: docker:20.10.22-git
  services:
    - docker:20.10.22-dind
  before_script:
    - echo "${CI_REGISTRY_PASSWORD}" | docker login --username "${CI_REGISTRY_USER}" --password-stdin "${CI_REGISTRY}"
  script:
    - BUILD_IMAGE="`cat ci_build_image.txt`"
    - RELEASE_IMAGE_TAG="`git show -s --format=%cd-%h --date=format:'%Y.%m.%d-%H%M%S'`"
    - RELEASE_IMAGE="${RELEASE_IMAGE_REPOSITORY}:${RELEASE_IMAGE_TAG}"
    - docker image pull "${BUILD_IMAGE}"
    - docker image tag "${BUILD_IMAGE}" "${RELEASE_IMAGE}"
    - docker image push "${RELEASE_IMAGE}"
    - echo -n "${RELEASE_IMAGE}" > ci_release_image.txt
  artifacts:
    paths:
      - ci_release_image.txt
  dependencies:
    - Build
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PROJECT_PATH == $PROJECT_PATH'
  tags:
    - cg
    - docker
